Index: cpukit/libblock/src/bdbuf.c
===================================================================
--- cpukit/libblock/src/bdbuf.c	(revision f14a21df691328cefa1464fc5ef13c0584bbfaf3)
+++ cpukit/libblock/src/bdbuf.c	(revision 0d15414ed6c144f7f7e4ce63476b3eb9b94acceb)
@@ -1370,5 +1604,5 @@
 #endif
 
-  bd = rtems_bdbuf_get_buffer (dd->phys_dev, pool, block + dd->start, false);
+  bd = rtems_bdbuf_get_buffer (dd, bds_per_group, block + dd->start, false);
 
   if (bd->state == RTEMS_BDBUF_STATE_MODIFIED)
@@ -1376,11 +1610,11 @@
   else
     bd->state = RTEMS_BDBUF_STATE_ACCESS;
-  
-  rtems_bdbuf_unlock_pool (pool);
+
+  rtems_bdbuf_unlock_cache ();
 
   rtems_disk_release(dd);
 
   *bdp = bd;
-  
+
   return RTEMS_SUCCESSFUL;
 }
@@ -1413,9 +1647,12 @@
 {
   rtems_disk_device*    dd;
-  rtems_bdbuf_pool*     pool;
   rtems_bdbuf_buffer*   bd = NULL;
   uint32_t              read_ahead_count;
   rtems_blkdev_request* req;
-  
+  size_t                bds_per_group;
+  
+  if (!bdbuf_cache.initialised)
+    return RTEMS_NOT_CONFIGURED;
+
   /*
    * @todo This type of request structure is wrong and should be removed.
@@ -1428,12 +1665,19 @@
 
   /*
-   * Do not hold the pool lock when obtaining the disk table.
+   * Do not hold the cache lock when obtaining the disk table.
    */
   dd = rtems_disk_obtain (device);
-  if (dd == NULL)
+  if (!dd)
     return RTEMS_INVALID_ID;
   
   if (block >= dd->size) {
     rtems_disk_release(dd);
+    return RTEMS_INVALID_NUMBER;
+  }
+  
+  bds_per_group = rtems_bdbuf_bds_per_group (dd->block_size);
+  if (!bds_per_group)
+  {
+    rtems_disk_release (dd);
     return RTEMS_INVALID_NUMBER;
   }
@@ -1458,7 +1702,5 @@
     read_ahead_count = dd->size - block;
 
-  pool = rtems_bdbuf_get_pool (dd->phys_dev->pool);
-
-  rtems_bdbuf_lock_pool (pool);
+  rtems_bdbuf_lock_cache ();
 
   while (req->bufnum < read_ahead_count)
@@ -1472,5 +1714,5 @@
      * caller.
      */
-    bd = rtems_bdbuf_get_buffer (dd->phys_dev, pool,
+    bd = rtems_bdbuf_get_buffer (dd, bds_per_group,
                                  block + dd->start + req->bufnum,
                                  req->bufnum == 0 ? false : true);
@@ -1515,12 +1757,12 @@
   {
     /*
-     * Unlock the pool. We have the buffer for the block and it will be in the
+     * Unlock the cache. We have the buffer for the block and it will be in the
      * access or transfer state. We may also have a number of read ahead blocks
      * if we need to transfer data. At this point any other threads can gain
-     * access to the pool and if they are after any of the buffers we have they
-     * will block and be woken when the buffer is returned to the pool.
+     * access to the cache and if they are after any of the buffers we have
+     * they will block and be woken when the buffer is returned to the cache.
      *
      * If a transfer is needed the I/O operation will occur with pre-emption
-     * enabled and the pool unlocked. This is a change to the previous version
+     * enabled and the cache unlocked. This is a change to the previous version
      * of the bdbuf code.
      */
@@ -1536,5 +1778,5 @@
                          0, &out);
                          
-    rtems_bdbuf_unlock_pool (pool);
+    rtems_bdbuf_unlock_cache ();
 
     req->req = RTEMS_BLKDEV_REQ_READ;
@@ -1568,5 +1810,5 @@
     }
 
-    rtems_bdbuf_lock_pool (pool);
+    rtems_bdbuf_lock_cache ();
 
     for (b = 1; b < req->bufnum; b++)
@@ -1589,5 +1831,5 @@
     bd->state = RTEMS_BDBUF_STATE_ACCESS;
 
-  rtems_bdbuf_unlock_pool (pool);
+  rtems_bdbuf_unlock_cache ();
   rtems_disk_release (dd);
 
@@ -1600,12 +1842,11 @@
 rtems_bdbuf_release (rtems_bdbuf_buffer* bd)
 {
-  rtems_bdbuf_pool* pool;
+  if (!bdbuf_cache.initialised)
+    return RTEMS_NOT_CONFIGURED;
 
   if (bd == NULL)
     return RTEMS_INVALID_ADDRESS;
 
-  pool = rtems_bdbuf_get_pool (bd->pool);
-
-  rtems_bdbuf_lock_pool (pool);
+  rtems_bdbuf_lock_cache ();
 
 #if RTEMS_BDBUF_TRACE
@@ -1615,5 +1856,5 @@
   if (bd->state == RTEMS_BDBUF_STATE_ACCESS_MODIFIED)
   {
-    rtems_bdbuf_append_modified (pool, bd);
+    rtems_bdbuf_append_modified (bd);
   }
   else
@@ -1625,10 +1866,15 @@
      */
     if (bd->state == RTEMS_BDBUF_STATE_READ_AHEAD)
-      rtems_chain_prepend (&pool->ready, &bd->link);
+      rtems_chain_prepend (&bdbuf_cache.ready, &bd->link);
     else
     {
       bd->state = RTEMS_BDBUF_STATE_CACHED;
-      rtems_chain_append (&pool->lru, &bd->link);
-    }
+      rtems_chain_append (&bdbuf_cache.lru, &bd->link);
+    }
+
+    /*
+     * One less user for the group of bds.
+     */
+    bd->group->users--;
   }
   
@@ -1638,20 +1884,20 @@
    */
   if (bd->waiters)
-    rtems_bdbuf_wake (pool->access, &pool->access_waiters);
+    rtems_bdbuf_wake (bdbuf_cache.access, &bdbuf_cache.access_waiters);
   else
   {
     if (bd->state == RTEMS_BDBUF_STATE_READ_AHEAD)
     {
-      if (rtems_chain_has_only_one_node (&pool->ready))
-        rtems_bdbuf_wake (pool->waiting, &pool->wait_waiters);
+      if (rtems_chain_has_only_one_node (&bdbuf_cache.ready))
+        rtems_bdbuf_wake (bdbuf_cache.waiting, &bdbuf_cache.wait_waiters);
     }
     else
     {
-      if (rtems_chain_has_only_one_node (&pool->lru))
-        rtems_bdbuf_wake (pool->waiting, &pool->wait_waiters);
-    }
-  }
-  
-  rtems_bdbuf_unlock_pool (pool);
+      if (rtems_chain_has_only_one_node (&bdbuf_cache.lru))
+        rtems_bdbuf_wake (bdbuf_cache.waiting, &bdbuf_cache.wait_waiters);
+    }
+  }
+  
+  rtems_bdbuf_unlock_cache ();
 
   return RTEMS_SUCCESSFUL;
@@ -1661,12 +1907,11 @@
 rtems_bdbuf_release_modified (rtems_bdbuf_buffer* bd)
 {
-  rtems_bdbuf_pool* pool;
-
-  if (bd == NULL)
+  if (!bdbuf_cache.initialised)
+    return RTEMS_NOT_CONFIGURED;
+
+  if (!bd)
     return RTEMS_INVALID_ADDRESS;
 
-  pool = rtems_bdbuf_get_pool (bd->pool);
-
-  rtems_bdbuf_lock_pool (pool);
+  rtems_bdbuf_lock_cache ();
 
 #if RTEMS_BDBUF_TRACE
@@ -1676,10 +1921,10 @@
   bd->hold_timer = rtems_bdbuf_configuration.swap_block_hold;
   
-  rtems_bdbuf_append_modified (pool, bd);
+  rtems_bdbuf_append_modified (bd);
 
   if (bd->waiters)
-    rtems_bdbuf_wake (pool->access, &pool->access_waiters);
-  
-  rtems_bdbuf_unlock_pool (pool);
+    rtems_bdbuf_wake (bdbuf_cache.access, &bdbuf_cache.access_waiters);
+  
+  rtems_bdbuf_unlock_cache ();
 
   return RTEMS_SUCCESSFUL;
@@ -1689,6 +1934,5 @@
 rtems_bdbuf_sync (rtems_bdbuf_buffer* bd)
 {
-  rtems_bdbuf_pool* pool;
-  bool              available;
+  bool available;
 
 #if RTEMS_BDBUF_TRACE
@@ -1696,14 +1940,15 @@
 #endif
   
-  if (bd == NULL)
+  if (!bdbuf_cache.initialised)
+    return RTEMS_NOT_CONFIGURED;
+
+  if (!bd)
     return RTEMS_INVALID_ADDRESS;
 
-  pool = rtems_bdbuf_get_pool (bd->pool);
-
-  rtems_bdbuf_lock_pool (pool);
+  rtems_bdbuf_lock_cache ();
 
   bd->state = RTEMS_BDBUF_STATE_SYNC;
 
-  rtems_chain_append (&pool->sync, &bd->link);
+  rtems_chain_append (&bdbuf_cache.sync, &bd->link);
 
   rtems_bdbuf_wake_swapper ();
@@ -1725,5 +1970,5 @@
       case RTEMS_BDBUF_STATE_TRANSFER:
         bd->waiters++;
-        rtems_bdbuf_wait (pool, &pool->transfer, &pool->transfer_waiters);
+        rtems_bdbuf_wait (&bdbuf_cache.transfer, &bdbuf_cache.transfer_waiters);
         bd->waiters--;
         break;
@@ -1734,5 +1979,5 @@
   }
 
-  rtems_bdbuf_unlock_pool (pool);
+  rtems_bdbuf_unlock_cache ();
   
   return RTEMS_SUCCESSFUL;
@@ -1743,5 +1988,4 @@
 {
   rtems_disk_device*  dd;
-  rtems_bdbuf_pool*   pool;
   rtems_status_code   sc;
   rtems_event_set     out;
@@ -1751,36 +1995,37 @@
 #endif
 
-  /*
-   * Do not hold the pool lock when obtaining the disk table.
+  if (!bdbuf_cache.initialised)
+    return RTEMS_NOT_CONFIGURED;
+
+  /*
+   * Do not hold the cache lock when obtaining the disk table.
    */
   dd = rtems_disk_obtain (dev);
-  if (dd == NULL)
+  if (!dd)
     return RTEMS_INVALID_ID;
 
-  pool = rtems_bdbuf_get_pool (dd->pool);
-
-  /*
-   * Take the sync lock before locking the pool. Once we have the sync lock
-   * we can lock the pool. If another thread has the sync lock it will cause
-   * this thread to block until it owns the sync lock then it can own the
-   * pool. The sync lock can only be obtained with the pool unlocked.
-   */
-  
-  rtems_bdbuf_lock_sync (pool);
-  rtems_bdbuf_lock_pool (pool);  
-
-  /*
-   * Set the pool to have a sync active for a specific device and let the swap
+  /*
+   * Take the sync lock before locking the cache. Once we have the sync lock we
+   * can lock the cache. If another thread has the sync lock it will cause this
+   * thread to block until it owns the sync lock then it can own the cache. The
+   * sync lock can only be obtained with the cache unlocked.
+   */
+  
+  rtems_bdbuf_lock_sync ();
+  rtems_bdbuf_lock_cache ();  
+
+  /*
+   * Set the cache to have a sync active for a specific device and let the swap
    * out task know the id of the requester to wake when done.
    *
    * The swap out task will negate the sync active flag when no more buffers
-   * for the device are held on the modified for sync queues.
-   */
-  pool->sync_active    = true;
-  pool->sync_requester = rtems_task_self ();
-  pool->sync_device    = dev;
+   * for the device are held on the "modified for sync" queues.
+   */
+  bdbuf_cache.sync_active    = true;
+  bdbuf_cache.sync_requester = rtems_task_self ();
+  bdbuf_cache.sync_device    = dev;
   
   rtems_bdbuf_wake_swapper ();
-  rtems_bdbuf_unlock_pool (pool);
+  rtems_bdbuf_unlock_cache ();
   
   sc = rtems_event_receive (RTEMS_BDBUF_TRANSFER_SYNC,
@@ -1791,7 +2036,7 @@
     rtems_fatal_error_occurred (BLKDEV_FATAL_BDBUF_SWAPOUT_RE);
       
-  rtems_bdbuf_unlock_sync (pool);
-  
-  return rtems_disk_release(dd);
+  rtems_bdbuf_unlock_sync ();
+  
+  return rtems_disk_release (dd);
 }
 
@@ -1818,198 +2063,30 @@
 
 /**
- * Process the modified list of buffers. There us a sync or modified list that
- * needs to be handled.
- *
- * @param pid The pool id to process modified buffers on.
- * @param dev The device to handle. If -1 no device is selected so select the
- *            device of the first buffer to be written to disk.
- * @param chain The modified chain to process.
- * @param transfer The chain to append buffers to be written too.
- * @param sync_active If true this is a sync operation so expire all timers.
- * @param update_timers If true update the timers.
- * @param timer_delta It update_timers is true update the timers by this
- *                    amount.
+ * Swapout transfer to the driver. The driver will break this I/O into groups
+ * of consecutive write requests is multiple consecutive buffers are required
+ * by the driver.
+ *
+ * @param transfer The transfer transaction.
  */
 static void
-rtems_bdbuf_swapout_modified_processing (rtems_bdpool_id      pid,
-                                         dev_t*               dev,
-                                         rtems_chain_control* chain,
-                                         rtems_chain_control* transfer,
-                                         bool                 sync_active,
-                                         bool                 update_timers,
-                                         uint32_t             timer_delta)
-{
-  if (!rtems_chain_is_empty (chain))
-  {
-    rtems_chain_node* node = rtems_chain_head (chain);
-    node = node->next;
-
-    while (!rtems_chain_is_tail (chain, node))
-    {
-      rtems_bdbuf_buffer* bd = (rtems_bdbuf_buffer*) node;
-    
-      if (bd->pool == pid)
-      {
-        /*
-         * Check if the buffer's hold timer has reached 0. If a sync is active
-         * force all the timers to 0.
-         *
-         * @note Lots of sync requests will skew this timer. It should be based
-         *       on TOD to be accurate. Does it matter ?
-         */
-        if (sync_active)
-          bd->hold_timer = 0;
-  
-        if (bd->hold_timer)
-        {
-          if (update_timers)
-          {
-            if (bd->hold_timer > timer_delta)
-              bd->hold_timer -= timer_delta;
-            else
-              bd->hold_timer = 0;
-          }
-
-          if (bd->hold_timer)
-          {
-            node = node->next;
-            continue;
-          }
-        }
-
-        /*
-         * This assumes we can set dev_t to -1 which is just an
-         * assumption. Cannot use the transfer list being empty the sync dev
-         * calls sets the dev to use.
-         */
-        if (*dev == (dev_t)-1)
-          *dev = bd->dev;
-
-        if (bd->dev == *dev)
-        {
-          rtems_chain_node* next_node = node->next;
-          rtems_chain_node* tnode = rtems_chain_tail (transfer);
-    
-          /*
-           * The blocks on the transfer list are sorted in block order. This
-           * means multi-block transfers for drivers that require consecutive
-           * blocks perform better with sorted blocks and for real disks it may
-           * help lower head movement.
-           */
-
-          bd->state = RTEMS_BDBUF_STATE_TRANSFER;
-
-          rtems_chain_extract (node);
-
-          tnode = tnode->previous;
-          
-          while (node && !rtems_chain_is_head (transfer, tnode))
-          {
-            rtems_bdbuf_buffer* tbd = (rtems_bdbuf_buffer*) tnode;
-
-            if (bd->block > tbd->block)
-            {
-              rtems_chain_insert (tnode, node);
-              node = NULL;
-            }
-            else
-              tnode = tnode->previous;
-          }
-
-          if (node)
-            rtems_chain_prepend (transfer, node);
-          
-          node = next_node;
-        }
-        else
-        {
-          node = node->next;
-        }
-      }
-    }
-  }
-}
-
-/**
- * Process a pool's modified buffers. Check the sync list first then the
- * modified list extracting the buffers suitable to be written to disk. We have
- * a device at a time. The task level loop will repeat this operation while
- * there are buffers to be written. If the transfer fails place the buffers
- * back on the modified list and try again later. The pool is unlocked while
- * the buffers are being written to disk.
- *
- * @param pid The pool id to process modified buffers on.
- * @param timer_delta It update_timers is true update the timers by this
- *                    amount.
- * @param update_timers If true update the timers.
- * @param write_req The write request structure. There is only one.
- *
- * @retval true Buffers where written to disk so scan again.
- * @retval false No buffers where written to disk.
- */
-static bool
-rtems_bdbuf_swapout_pool_processing (rtems_bdpool_id       pid,
-                                     unsigned long         timer_delta,
-                                     bool                  update_timers,
-                                     rtems_blkdev_request* write_req)
-{
-  rtems_bdbuf_pool*   pool = rtems_bdbuf_get_pool (pid);
-  rtems_chain_control transfer;
-  dev_t               dev = -1;
+rtems_bdbuf_swapout_write (rtems_bdbuf_swapout_transfer* transfer)
+{
   rtems_disk_device*  dd;
-  bool                transfered_buffers = true;
-
-  rtems_chain_initialize_empty (&transfer);
-    
-  rtems_bdbuf_lock_pool (pool);
-
-  /*
-   * When the sync is for a device limit the sync to that device. If the sync
-   * is for a buffer handle process the devices in the order on the sync
-   * list. This means the dev is -1.
-   */
-  if (pool->sync_active)
-    dev = pool->sync_device;
-
-  /*
-   * If we have any buffers in the sync queue move them to the modified
-   * list. The first sync buffer will select the device we use.
-   */
-  rtems_bdbuf_swapout_modified_processing (pid, &dev,
-                                           &pool->sync, &transfer,
-                                           true, false,
-                                           timer_delta);
-
-  /*
-   * Process the pool's modified list.
-   */
-  rtems_bdbuf_swapout_modified_processing (pid, &dev,
-                                           &pool->modified, &transfer,
-                                           pool->sync_active,
-                                           update_timers,
-                                           timer_delta);
-
-  /*
-   * We have all the buffers that have been modified for this device so the
-   * pool can be unlocked because the state of each buffer has been set to
-   * TRANSFER.
-   */
-  rtems_bdbuf_unlock_pool (pool);
+  
+#if RTEMS_BDBUF_TRACE
+  rtems_bdbuf_printf ("swapout transfer: %08x\n", transfer->dev);
+#endif
 
   /*
    * If there are buffers to transfer to the media transfer them.
    */
-  if (rtems_chain_is_empty (&transfer))
-    transfered_buffers = false;
-  else
+  if (!rtems_chain_is_empty (&transfer->bds))
   {
     /*
-     * Obtain the disk device. The pool's mutex has been released to avoid a
+     * Obtain the disk device. The cache's mutex has been released to avoid a
      * dead lock.
      */
-    dd = rtems_disk_obtain (dev);
-    if (dd == NULL)
-       transfered_buffers = false;
-    else
+    dd = rtems_disk_obtain (transfer->dev);
+    if (dd)
     {
       /*
@@ -2028,12 +2105,12 @@
        * trouble waiting to happen.
        */
-      write_req->status = RTEMS_RESOURCE_IN_USE;
-      write_req->error = 0;
-      write_req->bufnum = 0;
-
-      while (!rtems_chain_is_empty (&transfer))
+      transfer->write_req->status = RTEMS_RESOURCE_IN_USE;
+      transfer->write_req->error = 0;
+      transfer->write_req->bufnum = 0;
+
+      while (!rtems_chain_is_empty (&transfer->bds))
       {
         rtems_bdbuf_buffer* bd =
-          (rtems_bdbuf_buffer*) rtems_chain_get (&transfer);
+          (rtems_bdbuf_buffer*) rtems_chain_get (&transfer->bds);
 
         bool write = false;
@@ -2046,19 +2123,28 @@
          */
         
-        if ((dd->capabilities & RTEMS_BLKDEV_CAP_MULTISECTOR_CONT) &&
-            write_req->bufnum &&
+#if RTEMS_BDBUF_TRACE
+        rtems_bdbuf_printf ("swapout write: bd:%d, bufnum:%d mode:%s\n",
+                            bd->block, transfer->write_req->bufnum,
+                            dd->phys_dev->capabilities &
+                            RTEMS_BLKDEV_CAP_MULTISECTOR_CONT ? "MULIT" : "SCAT");
+#endif
+
+        if ((dd->phys_dev->capabilities & RTEMS_BLKDEV_CAP_MULTISECTOR_CONT) &&
+            transfer->write_req->bufnum &&
             (bd->block != (last_block + 1)))
         {
-          rtems_chain_prepend (&transfer, &bd->link);
+          rtems_chain_prepend (&transfer->bds, &bd->link);
           write = true;
         }
         else
         {
-          write_req->bufs[write_req->bufnum].user   = bd;
-          write_req->bufs[write_req->bufnum].block  = bd->block;
-          write_req->bufs[write_req->bufnum].length = dd->block_size;
-          write_req->bufs[write_req->bufnum].buffer = bd->buffer;
-          write_req->bufnum++;
-          last_block = bd->block;
+          rtems_blkdev_sg_buffer* buf;
+          buf = &transfer->write_req->bufs[transfer->write_req->bufnum];
+          transfer->write_req->bufnum++;
+          buf->user   = bd;
+          buf->block  = bd->block;
+          buf->length = dd->block_size;
+          buf->buffer = bd->buffer;
+          last_block  = bd->block;
         }
 
@@ -2068,6 +2154,6 @@
          */
 
-        if (rtems_chain_is_empty (&transfer) ||
-            (write_req->bufnum >= rtems_bdbuf_configuration.max_write_blocks))
+        if (rtems_chain_is_empty (&transfer->bds) ||
+            (transfer->write_req->bufnum >= rtems_bdbuf_configuration.max_write_blocks))
           write = true;
 
@@ -2077,28 +2163,32 @@
           uint32_t b;
 
+#if RTEMS_BDBUF_TRACE
+          rtems_bdbuf_printf ("swapout write: writing bufnum:%d\n",
+                              transfer->write_req->bufnum);
+#endif
           /*
-           * Perform the transfer. No pool locks, no preemption, only the disk
+           * Perform the transfer. No cache locks, no preemption, only the disk
            * device is being held.
            */
-          result = dd->ioctl (dd->phys_dev->dev,
-                              RTEMS_BLKIO_REQUEST, write_req);
+          result = dd->phys_dev->ioctl (dd->phys_dev->dev,
+                                        RTEMS_BLKIO_REQUEST, transfer->write_req);
 
           if (result < 0)
           {
-            rtems_bdbuf_lock_pool (pool);
+            rtems_bdbuf_lock_cache ();
               
-            for (b = 0; b < write_req->bufnum; b++)
+            for (b = 0; b < transfer->write_req->bufnum; b++)
             {
-              bd = write_req->bufs[b].user;
+              bd = transfer->write_req->bufs[b].user;
               bd->state  = RTEMS_BDBUF_STATE_MODIFIED;
               bd->error = errno;
 
               /*
-               * Place back on the pools modified queue and try again.
+               * Place back on the cache's modified queue and try again.
                *
                * @warning Not sure this is the best option but I do not know
                *          what else can be done.
                */
-              rtems_chain_append (&pool->modified, &bd->link);
+              rtems_chain_append (&bdbuf_cache.modified, &bd->link);
             }
           }
@@ -2115,29 +2205,30 @@
               rtems_fatal_error_occurred (BLKDEV_FATAL_BDBUF_SWAPOUT_RE);
 
-            rtems_bdbuf_lock_pool (pool);
-
-            for (b = 0; b < write_req->bufnum; b++)
+            rtems_bdbuf_lock_cache ();
+
+            for (b = 0; b < transfer->write_req->bufnum; b++)
             {
-              bd = write_req->bufs[b].user;
+              bd = transfer->write_req->bufs[b].user;
               bd->state = RTEMS_BDBUF_STATE_CACHED;
               bd->error = 0;
-
-              rtems_chain_append (&pool->lru, &bd->link);
+              bd->group->users--;
+              
+              rtems_chain_append (&bdbuf_cache.lru, &bd->link);
               
               if (bd->waiters)
-                rtems_bdbuf_wake (pool->transfer, &pool->transfer_waiters);
+                rtems_bdbuf_wake (bdbuf_cache.transfer, &bdbuf_cache.transfer_waiters);
               else
               {
-                if (rtems_chain_has_only_one_node (&pool->lru))
-                  rtems_bdbuf_wake (pool->waiting, &pool->wait_waiters);
+                if (rtems_chain_has_only_one_node (&bdbuf_cache.lru))
+                  rtems_bdbuf_wake (bdbuf_cache.waiting, &bdbuf_cache.wait_waiters);
               }
             }
           }
-
-          rtems_bdbuf_unlock_pool (pool);
-
-          write_req->status = RTEMS_RESOURCE_IN_USE;
-          write_req->error = 0;
-          write_req->bufnum = 0;
+              
+          rtems_bdbuf_unlock_cache ();
+
+          transfer->write_req->status = RTEMS_RESOURCE_IN_USE;
+          transfer->write_req->error = 0;
+          transfer->write_req->bufnum = 0;
         }
       }
@@ -2145,33 +2236,250 @@
       rtems_disk_release (dd);
     }
-  }
-
-  if (pool->sync_active && !  transfered_buffers)
-  {
-    rtems_id sync_requester = pool->sync_requester;
-    pool->sync_active = false;
-    pool->sync_requester = 0;
+    else
+    {
+      /*
+       * We have buffers but no device. Put the BDs back onto the
+       * ready queue and exit.
+       */
+      /* @todo fixme */
+    }
+  }
+}
+
+/**
+ * Process the modified list of buffers. There is a sync or modified list that
+ * needs to be handled so we have a common function to do the work.
+ *
+ * @param dev The device to handle. If -1 no device is selected so select the
+ *            device of the first buffer to be written to disk.
+ * @param chain The modified chain to process.
+ * @param transfer The chain to append buffers to be written too.
+ * @param sync_active If true this is a sync operation so expire all timers.
+ * @param update_timers If true update the timers.
+ * @param timer_delta It update_timers is true update the timers by this
+ *                    amount.
+ */
+static void
+rtems_bdbuf_swapout_modified_processing (dev_t*               dev,
+                                         rtems_chain_control* chain,
+                                         rtems_chain_control* transfer,
+                                         bool                 sync_active,
+                                         bool                 update_timers,
+                                         uint32_t             timer_delta)
+{
+  if (!rtems_chain_is_empty (chain))
+  {
+    rtems_chain_node* node = rtems_chain_head (chain);
+    node = node->next;
+
+    while (!rtems_chain_is_tail (chain, node))
+    {
+      rtems_bdbuf_buffer* bd = (rtems_bdbuf_buffer*) node;
+    
+      /*
+       * Check if the buffer's hold timer has reached 0. If a sync is active
+       * force all the timers to 0.
+       *
+       * @note Lots of sync requests will skew this timer. It should be based
+       *       on TOD to be accurate. Does it matter ?
+       */
+      if (sync_active)
+        bd->hold_timer = 0;
+  
+      if (bd->hold_timer)
+      {
+        if (update_timers)
+        {
+          if (bd->hold_timer > timer_delta)
+            bd->hold_timer -= timer_delta;
+          else
+            bd->hold_timer = 0;
+        }
+
+        if (bd->hold_timer)
+        {
+          node = node->next;
+          continue;
+        }
+      }
+
+      /*
+       * This assumes we can set dev_t to -1 which is just an
+       * assumption. Cannot use the transfer list being empty the sync dev
+       * calls sets the dev to use.
+       */
+      if (*dev == (dev_t)-1)
+        *dev = bd->dev;
+
+      if (bd->dev == *dev)
+      {
+        rtems_chain_node* next_node = node->next;
+        rtems_chain_node* tnode = rtems_chain_tail (transfer);
+    
+        /*
+         * The blocks on the transfer list are sorted in block order. This
+         * means multi-block transfers for drivers that require consecutive
+         * blocks perform better with sorted blocks and for real disks it may
+         * help lower head movement.
+         */
+
+        bd->state = RTEMS_BDBUF_STATE_TRANSFER;
+
+        rtems_chain_extract (node);
+
+        tnode = tnode->previous;
+          
+        while (node && !rtems_chain_is_head (transfer, tnode))
+        {
+          rtems_bdbuf_buffer* tbd = (rtems_bdbuf_buffer*) tnode;
+
+          if (bd->block > tbd->block)
+          {
+            rtems_chain_insert (tnode, node);
+            node = NULL;
+          }
+          else
+            tnode = tnode->previous;
+        }
+        
+        if (node)
+          rtems_chain_prepend (transfer, node);
+          
+        node = next_node;
+      }
+      else
+      {
+        node = node->next;
+      }
+    }
+  }
+}
+
+/**
+ * Process the cache's modified buffers. Check the sync list first then the
+ * modified list extracting the buffers suitable to be written to disk. We have
+ * a device at a time. The task level loop will repeat this operation while
+ * there are buffers to be written. If the transfer fails place the buffers
+ * back on the modified list and try again later. The cache is unlocked while
+ * the buffers are being written to disk.
+ *
+ * @param timer_delta It update_timers is true update the timers by this
+ *                    amount.
+ * @param update_timers If true update the timers.
+ * @param transfer The transfer transaction data.
+ *
+ * @retval true Buffers where written to disk so scan again.
+ * @retval false No buffers where written to disk.
+ */
+static bool
+rtems_bdbuf_swapout_processing (unsigned long                 timer_delta,
+                                bool                          update_timers,
+                                rtems_bdbuf_swapout_transfer* transfer)
+{
+  rtems_bdbuf_swapout_worker* worker;
+  bool                        transfered_buffers = false;
+
+  rtems_bdbuf_lock_cache ();
+
+  /*
+   * If a sync is active do not use a worker because the current code does not
+   * cleaning up after. We need to know the buffers have been written when
+   * syncing to release sync lock and currently worker threads do not return to
+   * here. We do not know the worker is the last in a sequence of sync writes
+   * until after we have it running so we do not know to tell it to release the
+   * lock. The simplest solution is to get the main swap out task perform all
+   * sync operations.
+   */
+  if (bdbuf_cache.sync_active)
+    worker = NULL;
+  else
+  {
+    worker = (rtems_bdbuf_swapout_worker*)
+      rtems_chain_get (&bdbuf_cache.swapout_workers);
+    if (worker)
+      transfer = &worker->transfer;
+  }
+  
+  rtems_chain_initialize_empty (&transfer->bds);
+  transfer->dev = -1;
+  
+  /*
+   * When the sync is for a device limit the sync to that device. If the sync
+   * is for a buffer handle process the devices in the order on the sync
+   * list. This means the dev is -1.
+   */
+  if (bdbuf_cache.sync_active)
+    transfer->dev = bdbuf_cache.sync_device;
+  
+  /*
+   * If we have any buffers in the sync queue move them to the modified
+   * list. The first sync buffer will select the device we use.
+   */
+  rtems_bdbuf_swapout_modified_processing (&transfer->dev,
+                                           &bdbuf_cache.sync,
+                                           &transfer->bds,
+                                           true, false,
+                                           timer_delta);
+
+  /*
+   * Process the cache's modified list.
+   */
+  rtems_bdbuf_swapout_modified_processing (&transfer->dev,
+                                           &bdbuf_cache.modified,
+                                           &transfer->bds,
+                                           bdbuf_cache.sync_active,
+                                           update_timers,
+                                           timer_delta);
+
+  /*
+   * We have all the buffers that have been modified for this device so the
+   * cache can be unlocked because the state of each buffer has been set to
+   * TRANSFER.
+   */
+  rtems_bdbuf_unlock_cache ();
+
+  /*
+   * If there are buffers to transfer to the media transfer them.
+   */
+  if (!rtems_chain_is_empty (&transfer->bds))
+  {
+    if (worker)
+    {
+      rtems_status_code sc = rtems_event_send (worker->id,
+                                               RTEMS_BDBUF_SWAPOUT_SYNC);
+      if (sc != RTEMS_SUCCESSFUL)
+        rtems_fatal_error_occurred (RTEMS_BLKDEV_FATAL_BDBUF_SO_WAKE);
+    }
+    else
+    {
+      rtems_bdbuf_swapout_write (transfer);
+    }
+    
+    transfered_buffers = true;
+  }
+   
+  if (bdbuf_cache.sync_active && !transfered_buffers)
+  {
+    rtems_id sync_requester;
+    rtems_bdbuf_lock_cache ();
+    sync_requester = bdbuf_cache.sync_requester;
+    bdbuf_cache.sync_active = false;
+    bdbuf_cache.sync_requester = 0;
+    rtems_bdbuf_unlock_cache ();
     if (sync_requester)
       rtems_event_send (sync_requester, RTEMS_BDBUF_TRANSFER_SYNC);
   }
   
-  return  transfered_buffers;
-}
-
-/**
- * Body of task which takes care on flushing modified buffers to the disk.
- *
- * @param arg The task argument which is the context.
- */
-static rtems_task
-rtems_bdbuf_swapout_task (rtems_task_argument arg)
-{
-  rtems_bdbuf_context*  context = (rtems_bdbuf_context*) arg;
-  rtems_blkdev_request* write_req;
-  uint32_t              period_in_ticks;
-  const uint32_t        period_in_msecs = rtems_bdbuf_configuration.swapout_period;
-  uint32_t              timer_delta;
-  rtems_status_code     sc;
-
+  return transfered_buffers;
+}
+
+/**
+ * Allocate the write request and initialise it for good measure.
+ *
+ * @return rtems_blkdev_request* The write reference memory.
+ */
+static rtems_blkdev_request*
+rtems_bdbuf_swapout_writereq_alloc (void)
+{
   /*
    * @note chrisj The rtems_blkdev_request and the array at the end is a hack.
